Loading...
Searching...
No Matches
itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType > Class Template Reference

`#include <itkGPUResampleImageFilter.h>`

## Detailed Description

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>
class itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >

GPU version of ResampleImageFilter.

Author
  Denis P. Shamonin and Marius Staring. Division of Image Processing, Department of Radiology, Leiden, The Netherlands

Note
  This work was funded by the Netherlands Organisation for Scientific Research (NWO NRG-2010.02 and NWO 639.021.124).

Definition at line 50 of file itkGPUResampleImageFilter.h.

Inheritance diagram for itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >:
[legend]

## Public Types

using | CompositeTransformBaseType = GPUCompositeTransformBase<InterpolatorPrecisionType, InputImageDimension>
using | ConstPointer = SmartPointer<const Self>
using | CPUSuperclass
using | ExtrapolatorType = typename CPUSuperclass::ExtrapolatorType
using | GPUBSplineBaseTransformType = GPUBSplineBaseTransform<InterpolatorPrecisionType, InputImageDimension>
using | GPUBSplineInterpolatorCoefficientImagePointer = typename GPUBSplineInterpolatorType::GPUCoefficientImagePointer
using | GPUBSplineInterpolatorCoefficientImageType = typename GPUBSplineInterpolatorType::GPUCoefficientImageType
using | GPUBSplineInterpolatorDataManagerPointer = typename GPUBSplineInterpolatorType::GPUDataManagerPointer
using | GPUBSplineInterpolatorType = GPUBSplineInterpolateImageFunction<InputImageType, InterpolatorPrecisionType>
using | GPUDataManagerPointer = typename GPUDataManager::Pointer
using | GPUInputImage = typename GPUTraits<TInputImage>::Type
using | GPUKernelManagerPointer = typename OpenCLKernelManager::Pointer
using | GPUOutputImage = typename GPUTraits<TOutputImage>::Type
using | GPUSuperclass = GPUImageToImageFilter<TInputImage, TOutputImage, CPUSuperclass>
using | IndexType = typename CPUSuperclass::IndexType
using | InputImageRegionType = typename CPUSuperclass::InputImageRegionType
using | InputImageType = TInputImage
using | InterpolatorPrecisionType = TInterpolatorPrecisionType
using | InterpolatorType = typename CPUSuperclass::InterpolatorType
using | OutputImagePixelType = typename GPUSuperclass::OutputImagePixelType
using | OutputImageRegionType = typename CPUSuperclass::OutputImageRegionType
using | OutputImageType = TOutputImage
using | Pointer = SmartPointer<Self>
using | Self = GPUResampleImageFilter
using | SizeType = typename CPUSuperclass::SizeType
using | TransformType = typename CPUSuperclass::TransformType
Public Types inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, ResampleImageFilter< TInputImage, TOutputImage, float, float > >
using | ConstPointer
using | InputImageConstPointer
using | InputImagePixelType
using | InputImagePointer
using | InputImageRegionType
using | InputImageType
using | OutputImageType
using | Pointer
using | Self
using | Superclass

## Public Member Functions

virtual const char * | GetClassName () const
virtual unsigned int | GetRequestedNumberOfSplits () const
| ITK_DISALLOW_COPY_AND_MOVE (GPUResampleImageFilter)
| itkStaticConstMacro (InputImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
void | SetExtrapolator (ExtrapolatorType *_arg) override
void | SetInterpolator (InterpolatorType *_arg) override
virtual void | SetRequestedNumberOfSplits (unsigned int _arg)
void | SetTransform (const TransformType *_arg) override
Public Member Functions inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, ResampleImageFilter< TInputImage, TOutputImage, float, float > >
virtual bool | GetGPUEnabled () const
virtual void | GPUEnabledOff ()
virtual void | GPUEnabledOn ()
void | GraftOutput (DataObject *graft) override
| ITK_DISALLOW_COPY_AND_MOVE (GPUImageToImageFilter)
| itkStaticConstMacro (InputImageDimension, unsigned int, TInputImage::ImageDimension)
virtual void | SetGPUEnabled (bool _arg)
void | SetNumberOfWorkUnits (ThreadIdType _arg) override

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, ResampleImageFilter< TInputImage, TOutputImage, float, float > >
static Pointer | New ()

## Protected Types

enum | GPUTransformTypeEnum { IdentityTransform = 1 , MatrixOffsetTransform , TranslationTransform , BSplineTransform , Else }

## Protected Member Functions

GPUBSplineBaseTransformType * | GetGPUBSplineBaseTransform (const std::vcl_size_t transformIndex)
bool | GetKernelIdFromTransformId (const std::vcl_size_t &index, std::vcl_size_t &kernelId) const
int | GetTransformHandle (const GPUTransformTypeEnum type) const
const GPUTransformTypeEnum | GetTransformType (const int &transformIndex) const
void | GPUGenerateData () override
| GPUResampleImageFilter ()
bool | HasTransform (const GPUTransformTypeEnum type) const
void | PrintSelf (std::ostream &os, Indent indent) const override
void | SetArgumentsForLoopKernelManager (const typename GPUInputImage::Pointer &input, const typename GPUOutputImage::Pointer &output)
void | SetArgumentsForPostKernelManager (const typename GPUInputImage::Pointer &input, const typename GPUOutputImage::Pointer &output)
void | SetArgumentsForPreKernelManager (const typename GPUOutputImage::Pointer &output)
void | SetBSplineTransformCoefficientsToGPU (const std::vcl_size_t transformIndex)
void | SetTransformParametersForLoopKernelManager (const std::vcl_size_t transformIndex)
| ~GPUResampleImageFilter () override=default
Protected Member Functions inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, ResampleImageFilter< TInputImage, TOutputImage, float, float > >
void | GenerateData () override
| GPUImageToImageFilter ()
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~GPUImageToImageFilter () override=default

## Private Types

using | TransformHandle = std::pair<int, bool>
using | TransformsHandle = std::map<GPUTransformTypeEnum, TransformHandle>

## Private Attributes

GPUDataManagerPointer | m_DeformationFieldBuffer {}
TransformsHandle | m_FilterLoopGPUKernelHandle {}
GPUDataManagerPointer | m_FilterParameters {}
std::vcl_size_t | m_FilterPostGPUKernelHandle {}
std::vcl_size_t | m_FilterPreGPUKernelHandle {}
GPUDataManagerPointer | m_InputGPUImageBase {}
GPUInterpolatorBase * | m_InterpolatorBase {}
bool | m_InterpolatorIsBSpline {}
std::vcl_size_t | m_InterpolatorSourceLoadedIndex {}
GPUKernelManagerPointer | m_LoopKernelManager {}
GPUDataManagerPointer | m_OutputGPUImageBase {}
GPUKernelManagerPointer | m_PostKernelManager {}
GPUKernelManagerPointer | m_PreKernelManager {}
unsigned int | m_RequestedNumberOfSplits {}
std::vcl_size_t | m_SourceIndex {}
std::vector< std::string > | m_Sources {}
GPUTransformBase * | m_TransformBase {}
bool | m_TransformIsCombo {}
std::vcl_size_t | m_TransformSourceLoadedIndex {}

## Additional Inherited Members

Protected Attributes inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, ResampleImageFilter< TInputImage, TOutputImage, float, float > >
OpenCLKernelManager::Pointer | m_GPUKernelManager

## Member Typedef Documentation

## CompositeTransformBaseType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::CompositeTransformBaseType = GPUCompositeTransformBase<InterpolatorPrecisionType, InputImageDimension>

Definition at line 98 of file itkGPUResampleImageFilter.h.

## ConstPointer

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::ConstPointer = SmartPointer<const Self>

Definition at line 65 of file itkGPUResampleImageFilter.h.

## CPUSuperclass

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::CPUSuperclass

Initial value:
ResampleImageFilter<TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType>

Definition at line 61 of file itkGPUResampleImageFilter.h.

## ExtrapolatorType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::ExtrapolatorType = typename CPUSuperclass::ExtrapolatorType

Definition at line 87 of file itkGPUResampleImageFilter.h.

## GPUBSplineBaseTransformType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUBSplineBaseTransformType = GPUBSplineBaseTransform<InterpolatorPrecisionType, InputImageDimension>

Typedefs for the B-spline transform.

Definition at line 107 of file itkGPUResampleImageFilter.h.

## GPUBSplineInterpolatorCoefficientImagePointer

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUBSplineInterpolatorCoefficientImagePointer = typename GPUBSplineInterpolatorType::GPUCoefficientImagePointer

Definition at line 103 of file itkGPUResampleImageFilter.h.

## GPUBSplineInterpolatorCoefficientImageType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUBSplineInterpolatorCoefficientImageType = typename GPUBSplineInterpolatorType::GPUCoefficientImageType

Definition at line 102 of file itkGPUResampleImageFilter.h.

## GPUBSplineInterpolatorDataManagerPointer

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUBSplineInterpolatorDataManagerPointer = typename GPUBSplineInterpolatorType::GPUDataManagerPointer

Definition at line 104 of file itkGPUResampleImageFilter.h.

## GPUBSplineInterpolatorType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUBSplineInterpolatorType = GPUBSplineInterpolateImageFunction<InputImageType, InterpolatorPrecisionType>

Typedefs for the B-spline interpolator.

Definition at line 101 of file itkGPUResampleImageFilter.h.

## GPUDataManagerPointer

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUDataManagerPointer = typename GPUDataManager::Pointer

Definition at line 97 of file itkGPUResampleImageFilter.h.

## GPUInputImage

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUInputImage = typename GPUTraits<TInputImage>::Type

Definition at line 80 of file itkGPUResampleImageFilter.h.

## GPUKernelManagerPointer

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUKernelManagerPointer = typename OpenCLKernelManager::Pointer

Other typedefs.

Definition at line 96 of file itkGPUResampleImageFilter.h.

## GPUOutputImage

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUOutputImage = typename GPUTraits<TOutputImage>::Type

Definition at line 81 of file itkGPUResampleImageFilter.h.

## GPUSuperclass

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUSuperclass = GPUImageToImageFilter<TInputImage, TOutputImage, CPUSuperclass>

Definition at line 63 of file itkGPUResampleImageFilter.h.

## IndexType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::IndexType = typename CPUSuperclass::IndexType

Definition at line 91 of file itkGPUResampleImageFilter.h.

## InputImageRegionType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::InputImageRegionType = typename CPUSuperclass::InputImageRegionType

Definition at line 88 of file itkGPUResampleImageFilter.h.

## InputImageType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::InputImageType = TInputImage

Some convenient typedefs.

Definition at line 78 of file itkGPUResampleImageFilter.h.

## InterpolatorPrecisionType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::InterpolatorPrecisionType = TInterpolatorPrecisionType

Definition at line 82 of file itkGPUResampleImageFilter.h.

## InterpolatorType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::InterpolatorType = typename CPUSuperclass::InterpolatorType

Superclass typedefs.

Definition at line 85 of file itkGPUResampleImageFilter.h.

## OutputImagePixelType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::OutputImagePixelType = typename GPUSuperclass::OutputImagePixelType

Definition at line 93 of file itkGPUResampleImageFilter.h.

## OutputImageRegionType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::OutputImageRegionType = typename CPUSuperclass::OutputImageRegionType

Definition at line 89 of file itkGPUResampleImageFilter.h.

## OutputImageType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::OutputImageType = TOutputImage

Definition at line 79 of file itkGPUResampleImageFilter.h.

## Pointer

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::Pointer = SmartPointer<Self>

Definition at line 64 of file itkGPUResampleImageFilter.h.

## Self

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::Self = GPUResampleImageFilter

Standard class typedefs.

Definition at line 60 of file itkGPUResampleImageFilter.h.

## SizeType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SizeType = typename CPUSuperclass::SizeType

Definition at line 90 of file itkGPUResampleImageFilter.h.

## TransformHandle

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::TransformHandle = std::pair<int, bool>

private

Definition at line 197 of file itkGPUResampleImageFilter.h.

## TransformsHandle

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::TransformsHandle = std::map<GPUTransformTypeEnum, TransformHandle>

private

Definition at line 198 of file itkGPUResampleImageFilter.h.

## TransformType

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

using itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::TransformType = typename CPUSuperclass::TransformType

Definition at line 86 of file itkGPUResampleImageFilter.h.

## Member Enumeration Documentation

## GPUTransformTypeEnum

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

enum itk::GPUResampleImageFilter::GPUTransformTypeEnum

protected

Enumerator
IdentityTransform |
MatrixOffsetTransform |
TranslationTransform |
BSplineTransform |
Else |

Definition at line 136 of file itkGPUResampleImageFilter.h.

## Constructor & Destructor Documentation

## GPUResampleImageFilter()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUResampleImageFilter | ( |  | ) |

protected

## ~GPUResampleImageFilter()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::~GPUResampleImageFilter | ( |  | ) |

override protected default

## Member Function Documentation

## GetClassName()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

virtual const char * itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::GPUImageToImageFilter< TInputImage, TOutputImage, ResampleImageFilter< TInputImage, TOutputImage, float, float > >.

## GetGPUBSplineBaseTransform()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUBSplineBaseTransformType * itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GetGPUBSplineBaseTransform | ( | const std::vcl_size_t | transformIndex | ) |

protected

Get the BSpline base transform.

## GetKernelIdFromTransformId()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

bool itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GetKernelIdFromTransformId | ( | const std::vcl_size_t & | index,
|  | std::vcl_size_t & | kernelId ) const

protected

Get a handle to the kernel given a handle to a transform.

## GetRequestedNumberOfSplits()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

virtual unsigned int itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GetRequestedNumberOfSplits | ( |  | ) | const

virtual

## GetTransformHandle()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

int itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GetTransformHandle | ( | const GPUTransformTypeEnum | type | ) | const

protected

Get a handle to a certain transform type.

## GetTransformType()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

const GPUTransformTypeEnum itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GetTransformType | ( | const int & | transformIndex | ) | const

protected

Get transform type.

## GPUGenerateData()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::GPUGenerateData | ( |  | ) |

override protected virtual

Reimplemented from itk::GPUImageToImageFilter< TInputImage, TOutputImage, ResampleImageFilter< TInputImage, TOutputImage, float, float > >.

## HasTransform()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

bool itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::HasTransform | ( | const GPUTransformTypeEnum | type | ) | const

protected

Check if a certain transform is present in the list of transforms.

## ITK_DISALLOW_COPY_AND_MOVE()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::ITK_DISALLOW_COPY_AND_MOVE | ( | GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType > |  | ) |

## itkStaticConstMacro() [1/2]

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::itkStaticConstMacro | ( | InputImageDimension | ,
|  | unsigned int | ,
|  | TInputImage::ImageDimension | )

ImageDimension constants

## itkStaticConstMacro() [2/2]

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::itkStaticConstMacro | ( | OutputImageDimension | ,
|  | unsigned int | ,
|  | TOutputImage::ImageDimension | )

## New()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

Pointer itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::New | ( |  | ) |

static

Method for creation through the object factory.

## PrintSelf()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

## SetArgumentsForLoopKernelManager()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SetArgumentsForLoopKernelManager | ( | const typename GPUInputImage::Pointer & | input,
|  | const typename GPUOutputImage::Pointer & | output )

protected

Set arguments for the loop kernel manager.

## SetArgumentsForPostKernelManager()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SetArgumentsForPostKernelManager | ( | const typename GPUInputImage::Pointer & | input,
|  | const typename GPUOutputImage::Pointer & | output )

protected

Set arguments for the post kernel manager.

## SetArgumentsForPreKernelManager()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SetArgumentsForPreKernelManager | ( | const typename GPUOutputImage::Pointer & | output | ) |

protected

Set arguments for the pre kernel manager.

## SetBSplineTransformCoefficientsToGPU()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SetBSplineTransformCoefficientsToGPU | ( | const std::vcl_size_t | transformIndex | ) |

protected

Set the B-spline transform coefficient images to the GPU.

## SetExtrapolator()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SetExtrapolator | ( | ExtrapolatorType * | _arg | ) |

override

Set the extrapolator. Not yet supported.

## SetInterpolator()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SetInterpolator | ( | InterpolatorType * | _arg | ) |

override

Set the interpolator.

## SetRequestedNumberOfSplits()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

virtual void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SetRequestedNumberOfSplits | ( | unsigned int | _arg | ) |

virtual

Set/Get the requested number of splits on OpenCL device. Only works for 3D images. For 1D, 2D are always equal 1.

## SetTransform()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SetTransform | ( | const TransformType * | _arg | ) |

override

Set the transform.

## SetTransformParametersForLoopKernelManager()

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

void itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::SetTransformParametersForLoopKernelManager | ( | const std::vcl_size_t | transformIndex | ) |

protected

Set arguments for the loop kernel manager.

## Field Documentation

## m_DeformationFieldBuffer

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUDataManagerPointer itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_DeformationFieldBuffer {}

private

Definition at line 194 of file itkGPUResampleImageFilter.h.

## m_FilterLoopGPUKernelHandle

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

TransformsHandle itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_FilterLoopGPUKernelHandle {}

private

Definition at line 231 of file itkGPUResampleImageFilter.h.

## m_FilterParameters

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUDataManagerPointer itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_FilterParameters {}

private

Definition at line 193 of file itkGPUResampleImageFilter.h.

## m_FilterPostGPUKernelHandle

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

std::vcl_size_t itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_FilterPostGPUKernelHandle {}

private

Definition at line 232 of file itkGPUResampleImageFilter.h.

## m_FilterPreGPUKernelHandle

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

std::vcl_size_t itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_FilterPreGPUKernelHandle {}

private

Definition at line 230 of file itkGPUResampleImageFilter.h.

## m_InputGPUImageBase

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUDataManagerPointer itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_InputGPUImageBase {}

private

Definition at line 191 of file itkGPUResampleImageFilter.h.

## m_InterpolatorBase

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUInterpolatorBase* itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_InterpolatorBase {}

private

Definition at line 188 of file itkGPUResampleImageFilter.h.

## m_InterpolatorIsBSpline

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

bool itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_InterpolatorIsBSpline {}

private

Definition at line 227 of file itkGPUResampleImageFilter.h.

## m_InterpolatorSourceLoadedIndex

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

std::vcl_size_t itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_InterpolatorSourceLoadedIndex {}

private

Definition at line 224 of file itkGPUResampleImageFilter.h.

## m_LoopKernelManager

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUKernelManagerPointer itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_LoopKernelManager {}

private

Definition at line 236 of file itkGPUResampleImageFilter.h.

## m_OutputGPUImageBase

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUDataManagerPointer itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_OutputGPUImageBase {}

private

Definition at line 192 of file itkGPUResampleImageFilter.h.

## m_PostKernelManager

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUKernelManagerPointer itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_PostKernelManager {}

private

Definition at line 237 of file itkGPUResampleImageFilter.h.

## m_PreKernelManager

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUKernelManagerPointer itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_PreKernelManager {}

private

Definition at line 235 of file itkGPUResampleImageFilter.h.

## m_RequestedNumberOfSplits

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

unsigned int itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_RequestedNumberOfSplits {}

private

Definition at line 195 of file itkGPUResampleImageFilter.h.

## m_SourceIndex

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

std::vcl_size_t itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_SourceIndex {}

private

Definition at line 222 of file itkGPUResampleImageFilter.h.

## m_Sources

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

std::vector<std::string> itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_Sources {}

private

Definition at line 221 of file itkGPUResampleImageFilter.h.

## m_TransformBase

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

GPUTransformBase* itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_TransformBase {}

private

Definition at line 189 of file itkGPUResampleImageFilter.h.

## m_TransformIsCombo

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

bool itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_TransformIsCombo {}

private

Definition at line 228 of file itkGPUResampleImageFilter.h.

## m_TransformSourceLoadedIndex

template<typename TInputImage, typename TOutputImage, typename TInterpolatorPrecisionType = float, typename TTransformPrecisionType = TInterpolatorPrecisionType>

std::vcl_size_t itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >::m_TransformSourceLoadedIndex {}

private

Definition at line 225 of file itkGPUResampleImageFilter.h.

Generated on 1768596610 for elastix by 1.15.0 |